/* 
 * keypad
 *
 * A suite of communication APIs for web and enterprise applications
 *
 * OpenAPI spec version: v1
 * Contact: fmalka@modulo.co.il
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = SeriousSIP.Client.SwaggerDateConverter;

namespace SeriousSIP.Model
{
    /// <summary>
    /// ConfigServiceParams
    /// </summary>
    [DataContract]
        public partial class ConfigServiceParams :  IEquatable<ConfigServiceParams>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ConfigServiceParams" /> class.
        /// </summary>
        /// <param name="instanceName">instanceName.</param>
        /// <param name="clientUrl">clientUrl.</param>
        /// <param name="autoStartSipServer">autoStartSipServer.</param>
        public ConfigServiceParams(string instanceName = default(string), string clientUrl = default(string), bool? autoStartSipServer = default(bool?))
        {
            this.InstanceName = instanceName;
            this.ClientUrl = clientUrl;
            this.AutoStartSipServer = autoStartSipServer;
        }
        
        /// <summary>
        /// Gets or Sets InstanceName
        /// </summary>
        [DataMember(Name="instanceName", EmitDefaultValue=false)]
        public string InstanceName { get; set; }

        /// <summary>
        /// Gets or Sets ClientUrl
        /// </summary>
        [DataMember(Name="clientUrl", EmitDefaultValue=false)]
        public string ClientUrl { get; set; }

        /// <summary>
        /// Gets or Sets AutoStartSipServer
        /// </summary>
        [DataMember(Name="autoStartSipServer", EmitDefaultValue=false)]
        public bool? AutoStartSipServer { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ConfigServiceParams {\n");
            sb.Append("  InstanceName: ").Append(InstanceName).Append("\n");
            sb.Append("  ClientUrl: ").Append(ClientUrl).Append("\n");
            sb.Append("  AutoStartSipServer: ").Append(AutoStartSipServer).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ConfigServiceParams);
        }

        /// <summary>
        /// Returns true if ConfigServiceParams instances are equal
        /// </summary>
        /// <param name="input">Instance of ConfigServiceParams to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ConfigServiceParams input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.InstanceName == input.InstanceName ||
                    (this.InstanceName != null &&
                    this.InstanceName.Equals(input.InstanceName))
                ) && 
                (
                    this.ClientUrl == input.ClientUrl ||
                    (this.ClientUrl != null &&
                    this.ClientUrl.Equals(input.ClientUrl))
                ) && 
                (
                    this.AutoStartSipServer == input.AutoStartSipServer ||
                    (this.AutoStartSipServer != null &&
                    this.AutoStartSipServer.Equals(input.AutoStartSipServer))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.InstanceName != null)
                    hashCode = hashCode * 59 + this.InstanceName.GetHashCode();
                if (this.ClientUrl != null)
                    hashCode = hashCode * 59 + this.ClientUrl.GetHashCode();
                if (this.AutoStartSipServer != null)
                    hashCode = hashCode * 59 + this.AutoStartSipServer.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }
}
